      PROGRAM SPIN
 
C
C     Read a version 2 plate kernel and perform
C     various tests and operations.
C
 
      IMPLICIT              NONE
 
      INCLUDE              'pltmax.inc'
 
      INTEGER               I
      INTEGER               J
      INTEGER               ID
      INTEGER               NP
      INTEGER               NB
      INTEGER               NV
      INTEGER               NCOM
      INTEGER               NBLEN
      INTEGER               NUMPLT
      INTEGER               NVXTOT
      INTEGER               NVX
      INTEGER               PLTID
      INTEGER               VNUM
      INTEGER               NAFID
      INTEGER               VRTID
      INTEGER               SIDLT
      INTEGER               SIDGT
      INTEGER               BODEX
      INTEGER               MSKFLG
      INTEGER               MSKSET
      INTEGER               NPINVX
      INTEGER               NFILL
      INTEGER               NPVTOT
      INTEGER               MAXNPP
      INTEGER               POVUN
      INTEGER               NBRS     ( 3 )
      INTEGER               NVOX     ( 3 )
      INTEGER               VLOUT    ( 3 )
      INTEGER               VPHIST   ( 0: 1000 )
      INTEGER               PVXLST   ( MAXNPV )
      INTEGER               PLATES   ( MAXEDG )
 
      DOUBLE PRECISION      AREA
      DOUBLE PRECISION      TAREA
      DOUBLE PRECISION      LNGSID
      DOUBLE PRECISION      VOXSIZ
      DOUBLE PRECISION      SIDMIN
      DOUBLE PRECISION      SIDMAX
      DOUBLE PRECISION      VDOT
      DOUBLE PRECISION      MAXELE
      DOUBLE PRECISION      VOXORI   ( 3 )
      DOUBLE PRECISION      NRNUM    ( 3 )
      DOUBLE PRECISION      CENTER   ( 3 )
      DOUBLE PRECISION      NORMAL   ( 3 )
      DOUBLE PRECISION      BEXT     ( 2, 3 )
      DOUBLE PRECISION      VOUT     ( 3 )
      DOUBLE PRECISION      VOUT3    ( 3, 3 )
 
      CHARACTER*(9)         TASK
      CHARACTER*(20)        BODNAM
      CHARACTER*(80)        PLTNAM
      CHARACTER*(80)        POVFIL
      CHARACTER*(MAXCLN)    COMS   ( MAXCOM )
 
 
 
C      CALL ERRACT ( 'set', 'report' )
 
      CALL CHKIN ( 'spin' )
 
      WRITE(*,*) 'Enter plate model file name:'
      READ(*,9000) PLTNAM
      CALL RDPLAT ( PLTNAM )
 
      CALL PLTOT ( NB, NP, NV )
 
      WRITE(*,*) ' '
      WRITE(*,*) 'number of bodies   = ', NB
      WRITE(*,*) 'number of plates   = ', NP
      WRITE(*,*) 'number of vertices = ', NV
 
      CALL VOXSUM ( 1, NVOX, VOXSIZ, VOXORI, NVXTOT, NVX )
 
      WRITE(*,*) ' '
      WRITE(*,*) 'number of voxels  = ', NVOX
      WRITE(*,*) 'voxel size        = ', VOXSIZ
      WRITE(*,*) 'voxel grid origin = ', VOXORI
 
C      WRITE(*,*) 'nvxtot = ', NVXTOT
C      WRITE(*,*) 'nvx    = ', NVX
 
      WRITE(*,*) ' '
 
C
C     Compute averaged normal each vertex.
C
 
      DO I = 1, NP
 
 
 
      END DO
 
 
C
C     Test diffrerent features.
C
 
      WRITE(*,*) ' '
      WRITE(*,*) 'enter command (type ''help'' for a list):'
      READ(*,9000) TASK
 9000 FORMAT( A )
 
      DO WHILE ( (TASK .NE. 'quit') .AND. (TASK .NE. 'exit') )
 
         IF ( TASK .EQ. 'help' ) THEN
 
            WRITE(*,*) 'nam2dx: body name to index'
            WRITE(*,*) 'dx2nam: body index to name'
            WRITE(*,*) 'bid2dx: NAIF id to index'
            WRITE(*,*) 'dx2bid: body index to NAIF id'
            WRITE(*,*) 'tot_area: total surface area of model'
            WRITE(*,*) 'com: kernel comments'
            WRITE(*,*) 'ext: plate model extents'
            WRITE(*,*) 'cen: plate centers'
            WRITE(*,*) 'dot: <center,normal> dot product'
            WRITE(*,*) 'nrm: plate normals'
            WRITE(*,*) 'unr: plate unit normals'
            WRITE(*,*) 'allvrtplt: given vertex, list plates it shares'
            WRITE(*,*) 'sid: length of longest side'
            WRITE(*,*) 'sidsum: longest side summary'
            WRITE(*,*) 'allnthvrt: given vertex ID, give coordinates'
            WRITE(*,*) 'mask: given a plate, is it occluded?'
            WRITE(*,*) 'masksum: number of occluded plates'
            WRITE(*,*) 'allnthplv: all plate vertices'
            WRITE(*,*) 'voxplt: input voxel, output plate'
            WRITE(*,*) 'allvoxplt: all voxels and plate members'
            WRITE(*,*) 'voxsum: voxel-plate summary'
            WRITE(*,*) 'pov: output pov triangle data'
            WRITE(*,*) 'povsmo: output pov smooth triangle data'
            WRITE(*,*) 'povmrk: mark in red plates with no view'
            WRITE(*,*) 'nbr: given plate id, list neighbors'
            WRITE(*,*) 'allnbr: list all plate neighbors'
            WRITE(*,*) 'load: load a new plate kernel'
 
         ELSE IF ( TASK .EQ. 'nam2dx' ) THEN
 
            WRITE(*,*) 'Enter body name'
            READ(*,9000) BODNAM
 
            CALL NAM2DX ( BODNAM, BODEX )
 
            WRITE(*,*) 'body index = ', BODEX
 
         ELSE IF ( TASK .EQ. 'dx2nam' ) THEN
 
            WRITE(*,*) 'Enter body index'
            READ(*,*) BODEX
 
            CALL DX2NAM ( BODEX, BODNAM )
 
            WRITE(*,*) 'body name = ', BODNAM
 
 
         ELSE IF ( TASK .EQ. 'bid2dx' ) THEN
 
            WRITE(*,*) 'Enter NAIF body ID'
            READ(*,*) NAFID
 
            CALL BID2DX ( NAFID, BODEX )
 
            WRITE(*,*) 'body index = ', BODEX
 
 
         ELSE IF ( TASK .EQ. 'dx2bid' ) THEN
 
            WRITE(*,*) 'Enter body index'
            READ(*,*) BODEX
 
            CALL DX2BID ( BODEX, NAFID )
 
            WRITE(*,*) 'NAIF body ID = ', NAFID
 
 
C
C     Obtain the total surface area of the plate model.
C
         ELSE IF ( TASK .EQ. 'tot_area' ) THEN
 
            TAREA = 0.D0
            DO I = 1, NP
               CALL NTHPLA ( I, AREA )
               TAREA = TAREA + AREA
            END DO
 
            WRITE(*,*) 'total area = ', TAREA,' km^2'
 
C
C     Print out plate kernel user comments.
C
 
         ELSE IF ( TASK .EQ. 'com' ) THEN
 
            CALL KERCOM ( 1, NCOM, COMS )
 
            DO I = 1, NCOM
               WRITE(*,*) COMS(I)(1:NBLEN(COMS(I)))
            END DO
 
         ELSE IF ( TASK .EQ. 'ext' ) THEN
 
            CALL BEXTNT ( 1, BEXT )
            WRITE(*,*) 'xmin = ', BEXT(1,1)
            WRITE(*,*) 'xmax = ', BEXT(2,1)
            WRITE(*,*) 'ymin = ', BEXT(1,2)
            WRITE(*,*) 'ymax = ', BEXT(2,2)
            WRITE(*,*) 'zmin = ', BEXT(1,3)
            WRITE(*,*) 'zmax = ', BEXT(2,3)
 
 
         ELSE IF ( TASK .EQ. 'cen' ) THEN
 
            DO I = 1, NP
               CALL NTHPLC ( I, CENTER )
               WRITE(*,*) I, CENTER
            END DO
 
 
         ELSE IF ( TASK .EQ. 'dot' ) THEN
 
            DO I = 1, NP
               CALL NTHPLC ( I, CENTER )
               CALL NTHPUN ( I, NRNUM )
               WRITE(*,*) I, VDOT(CENTER,NRNUM)
            END DO
 
 
 
         ELSE IF ( TASK .EQ. 'nrm' ) THEN
 
            DO I = 1, NP
               CALL NTHPLN ( I, NORMAL )
               WRITE(*,*) I, NORMAL
            END DO
 
         ELSE IF ( TASK .EQ. 'unr' ) THEN
 
            DO I = 1, NP
               CALL NTHPUN ( I, NRNUM )
               WRITE(*,*) I, NRNUM
            END DO
 
         ELSE IF ( TASK .EQ. 'allvrtplt' ) THEN
 
            DO I = 1, NV
               CALL VRTPLT ( I, NUMPLT, PLATES )
               WRITE(*,*) 'vertex = ', I,
     .                    ' number of plates = ', NUMPLT,
     .                    ' plates = ', (PLATES(J),J=1,NUMPLT)
            END DO
 
         ELSE IF ( TASK .EQ. 'sid' ) THEN
 
            DO I = 1, NP
               CALL NTHSID ( I, LNGSID )
               WRITE(*,*) I, LNGSID
            END DO
 
 
         ELSE IF ( TASK .EQ. 'sidsum' ) THEN
 
            SIDLT = 0
            SIDGT = 0
            SIDMIN = +9.D9
            SIDMAX = -9.D9
 
            DO I = 1, NP
               CALL NTHSID ( I, LNGSID )
               IF ( LNGSID .LT. VOXSIZ ) SIDLT = SIDLT + 1
               IF ( LNGSID .GE. VOXSIZ ) SIDGT = SIDGT + 1
               SIDMIN = DMIN1( SIDMIN, LNGSID )
               SIDMAX = DMAX1( SIDMAX, LNGSID )
            END DO
 
 
            WRITE(*,*) '#plates long side < voxsiz = ', SIDLT
            WRITE(*,*) '#plates long side > voxsiz = ', SIDGT
            WRITE(*,*) 'minimum long side = ', SIDMIN
            WRITE(*,*) 'maximum long side = ', SIDMAX
            WRITE(*,*) 'voxel size = ', VOXSIZ
 
         ELSE IF ( TASK .EQ. 'allnthvrt' ) THEN
 
 
            DO I = 1, NV
               CALL NTHVRT ( I, VRTID, VOUT )
               WRITE(*,*) I, VRTID, VOUT
            END DO
 
 
         ELSE IF ( TASK .EQ. 'mask' ) THEN
 
            DO I = 1, NP
               CALL NTHMSK ( I, MSKFLG, MAXELE )
               WRITE(*,*) 'plate, maskflag, maxele = ', I, MSKFLG,
     .                     MAXELE
            END DO
 
         ELSE IF ( TASK .EQ. 'masksum' ) THEN
 
            MSKSET = 0
 
            DO I = 1, NP
               CALL NTHMSK ( I, MSKFLG )
               IF ( MSKFLG .EQ. 1 ) MSKSET = MSKSET + 1
            END DO
 
            WRITE(*,*) 'number of occluded plates = ', MSKSET
            WRITE(*,*) '(#occluded plates)/(#total plates) = ',
     .                 DBLE(MSKSET) / DBLE(NP)
 
         ELSE IF ( TASK .EQ. 'allnthplv' ) THEN
 
            DO I = 1, NP
               CALL NTHPLV ( I,VOUT3 )
               CALL NTHPVL ( I, ID, VLOUT )
               WRITE(*,*) ' '
               WRITE(*,*) 'plate  = ',I
               WRITE(*,*) 'vertex = ', VLOUT(1), (VOUT3(J,1),J=1,3)
               WRITE(*,*) 'vertex = ', VLOUT(2), (VOUT3(J,2),J=1,3)
               WRITE(*,*) 'vertex = ', VLOUT(3), (VOUT3(J,3),J=1,3)
            END DO
 
         ELSE IF ( TASK .EQ. 'voxplt' ) THEN
 
            WRITE(*,*) 'enter voxel number:'
            READ(*,*) VNUM
 
            CALL VOXPLT ( VNUM, NPINVX, PVXLST )
 
            IF ( NPINVX .GT. 0 ) THEN
               WRITE(*,*) NPINVX,' plates intersect voxel ',VNUM,': ',
     .                    (PVXLST(J),J=1,NPINVX)
            ELSE IF ( NPINVX .EQ. 0 ) THEN
               WRITE(*,*) 'Voxel ', VNUM, ' is empty.'
            END IF
 
         ELSE IF ( TASK .EQ. 'allvoxplt' ) THEN
 
            DO I = 1, NVXTOT
               CALL VOXPLT ( I, NPINVX, PVXLST )
               IF ( NPINVX .GT. 0 ) THEN
                  WRITE(*,*) NPINVX,' plates intersect voxel ',I,': ',
     .                       (PVXLST(J),J=1,NPINVX)
               ELSE IF ( NPINVX .EQ. 0 ) THEN
                  WRITE(*,*) 'Voxel ', I, ' is empty.'
               END IF
            END DO
 
 
         ELSE IF ( TASK .EQ. 'voxsum' ) THEN
 
            NFILL  = 0
            NPVTOT = 0
            MAXNPP = -99999
 
            DO I = 1, NVXTOT
               CALL VOXPLT ( I, NPINVX, PVXLST )
               MAXNPP = MAX0( MAXNPP, NPINVX )
               VPHIST(NPINVX) = VPHIST(NPINVX) + 1
               IF ( NPINVX .GT. 0 ) THEN
                  NFILL = NFILL + 1
                  NPVTOT = NPVTOT + NPINVX
               END IF
 
            END DO
 
            WRITE(*,*) '(filled voxels)/(all voxels) = ',
     .                  DBLE(NFILL)/DBLE(NVXTOT)
            WRITE(*,*) 'average plates per filled voxel =',
     .                 DBLE(NPVTOT) / DBLE(NFILL)
            WRITE(*,*) 'average plates per voxel =',
     .                 DBLE(NPVTOT) / DBLE(NVXTOT)
 
            WRITE(*,*) 'maximum plates per voxel = ', MAXNPP
            WRITE(*,*) ' '
            WRITE(*,*) 'voxel occupancy histogram:'
            WRITE(*,*) 'plates per voxel     count'
            WRITE(*,*) '----------------     -----'
 
            DO I = 0, MAXNPP
               WRITE(*,*) I,'                  ',VPHIST(I)
            END DO
 
         ELSE IF ( TASK .EQ. 'pov' ) THEN
 
            WRITE(*,*) 'Enter pov file name:'
            READ(*,9000) POVFIL
 
            CALL TXTOPN ( POVFIL, POVUN )
 
            DO I = 1, NP
               CALL POVTRI ( POVUN, I, 'GRAY' )
            END DO
 
            CLOSE ( POVUN )
 
         ELSE IF ( TASK .EQ. 'povsmo' ) THEN
 
            WRITE(*,*) 'Enter pov file name:'
            READ(*,9000) POVFIL
 
            CALL TXTOPN ( POVFIL, POVUN )
 
            DO I = 1, NP
               CALL POVTSM ( POVUN, I, 'GRAY' )
            END DO
 
            CLOSE ( POVUN )
 
         ELSE IF ( TASK .EQ. 'povmrk' ) THEN
 
            WRITE(*,*) 'Enter pov file name:'
            READ(*,9000) POVFIL
 
            CALL TXTOPN ( POVFIL, POVUN )
 
            DO I = 1, NP
               CALL NTHMSK ( I, MSKFLG )
               IF ( MSKFLG .EQ. 1 ) THEN
                  CALL POVTRI ( POVUN, I, 'GRAY' )
               ELSE
                  CALL POVTRI ( POVUN, I, 'RED' )
               END IF
            END DO
 
            CLOSE ( POVUN )
 
         ELSE IF ( TASK .EQ. 'nbr' ) THEN
 
            WRITE(*,*) 'enter plate ID:'
            READ(*,*) PLTID
 
            CALL PLTNBR ( PLTID, NBRS )
 
            WRITE(*,*) 'plate     = ', PLTID
            WRITE(*,*) 'neighbors = ', NBRS
 
         ELSE IF ( TASK .EQ. 'allnbr' ) THEN
 
            DO I = 1, NP
               CALL PLTNBR ( I, NBRS )
               WRITE(*,*) ' '
               WRITE(*,*) 'plate     = ', I
               WRITE(*,*) 'neighbors = ', NBRS
            END DO
 
         ELSE IF ( TASK .EQ. 'load' ) THEN
 
            WRITE(*,*) 'unloading ', PLTNAM
 
            CALL UNLDPL ()
 
            WRITE(*,*) 'Enter new plate model file name:'
            READ(*,9000) PLTNAM
            CALL RDPLAT ( PLTNAM )
 
            CALL PLTOT ( NB, NP, NV )
 
            WRITE(*,*) ' '
            WRITE(*,*) 'number of bodies   = ', NB
            WRITE(*,*) 'number of plates   = ', NP
            WRITE(*,*) 'number of vertices = ', NV
 
            CALL VOXSUM ( 1, NVOX, VOXSIZ, VOXORI, NVXTOT, NVX )
 
 
            WRITE(*,*) 'nvox   = ', NVOX
            WRITE(*,*) 'voxsiz = ', VOXSIZ
            WRITE(*,*) 'voxori = ', VOXORI
            WRITE(*,*) 'nvxtot = ', NVXTOT
            WRITE(*,*) 'nvx    = ', NVX
 
         END IF
 
C
C     Draw the plate model as seen from the
C     spacecraft at a given time.  Also draw the
C     outline of an instrument field of view.
C
         WRITE(*,*) ' '
         WRITE(*,*) 'enter new command:'
         READ(*,9000) TASK
 
      END DO
 
      CALL CHKOUT ( 'spin' )
 
      END
